/*
 * Copyright (C) 2013 Philippe Komma
 * 
 * This file is part of libSVDlp: a SVD calculation library
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIB_SVD_LP_H__
#define __LIB_SVD_LP_H__

#ifdef USE_EIGEN
	#include <Eigen/Dense>
#endif

#include "blaswrap.h"
#include "f2c.h"

typedef enum 
{
	SVD_COMPLETE,
	SVD_VALUES,
	SVD_SUBSET
} SVD_TYPE;

int dgesvd_(char *, char *, integer *, integer *, doublereal *, integer *, doublereal *, doublereal *, integer *, doublereal *, integer *, doublereal *, integer *, integer *);

int dgesdd_(char *, integer *, integer *, doublereal *, integer *, doublereal *, doublereal *, integer *, doublereal *, integer *, doublereal *, integer *, integer *, integer *);

#ifdef USE_EIGEN

int svdWrapper( Eigen::MatrixXd& A, SVD_TYPE svdType, Eigen::MatrixXd*& S, Eigen::MatrixXd*& U, Eigen::MatrixXd*& VT );

int sddWrapper( Eigen::MatrixXd& A, SVD_TYPE svdType, Eigen::MatrixXd*& S, Eigen::MatrixXd*& U, Eigen::MatrixXd*& VT );

#endif

#endif